<TeXmacs|1.99.2>

<style|mmxmanual>

<\body>
  \;

  <with|framed-color|<pattern|/Applications/TeXmacs-1.99.1.app/Contents/Resources/share/TeXmacs/misc/patterns/ice-dark-blue.png||>|<\framed>
    \ <center|> \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <strong|<em|>>
    <with|color|pastel magenta|>

    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|white|<name|Lindalg:>>
    \ <name|<with|color|white|Mathemagix><with|color|white|>><with|color|white|
    Package for Symbolic Resolution>

    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|white|of
    >

    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|white|Linear
    Differential Systems with Singularities<strong|><with|color|pastel
    magenta|<with|color|pastel magenta|<with|color|pastel
    magenta|<with|color|pastel magenta|<with|color|pastel
    magenta|<with|color|pastel magenta|>>>>>>>

    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ 
  </framed>>

  \;

  <\center>
    <with|color|black|<strong|S. S. Maddah>, M. A. Barkatou>

    <with|color|black|University of Limoges>

    <with|color|black|DMI, XLIM Institute><with|color|black|>

    <with|color|black|Last Updated: July 2015>
  </center>

  <with|color|white|>

  <name|Lindalg >is dedicated to the local analysis of
  <math|n<rsup|th>>-order linear differential equations and first order
  linear differential systems. At ordinary points, it suffices to consider
  Taylor series (power series). Any engineering student or scientist is
  familiar with their resolution procedure and popular computer systems
  always consider a package for this goal. However, singular points require
  further investigation based on an analysis of a Newton polygon and
  matricial manipulations. Differential equations with singularities arise
  from countless applications and encompass a vast body of contemporary
  academic literature. The package <name|Isolde> written in the computer
  algebra system <name|Maple> is dedicated to the symbolic resolution of such
  systems and more generally linear functional matrix equations (e.g.
  difference equations).

  On the other hand, the new package <name|Lindalg> sets a first milestone in
  providing the two-decade span of <name|Isolde> content in an open source
  software.

  <name|<hlink|<hlink|Mathemagix|www.mathemagix.org>|>> provides under GNU
  General Public License, a new high level general purpose language, for
  symbolic and certified numeric algorithms, that can be both interpreted by
  a shell or compiled.

  Before proceeding you might be interested in one of the following:

  <\itemize-dot>
    <item>Download <name|Mathemagix> and its tutorial:
    <hlink|<verbatim|www.mathemagix.org>|www.mathemagix.org>

    <item>Download the tutorial on formal reduction and remarks on
    implementation and underlying algorithms and

    <item>Download the set of example files for this manual:

    <hlink|<verbatim|www.unilim.fr/pages_perso/suzy.maddah/Research_.html>|www.unilim.fr/pages_perso/suzy.maddah/Research_.html>
  </itemize-dot>

  \;

  For any inquiries or report on bugs, please write to:
  <verbatim|suzy.maddah@etu.unilim.fr>

  This manual is written in TeXmacs : <verbatim|<hlink|www.texmacs.org|www.texmacs.org>>
  .

  <center|>

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark blue|
    Linear Singular Ordinary Differential Systems>
  </framed>

  \;

  Given such a system:

  <\equation*>
    <around*|[|A|]> <text| \ \ \ \ \ \ \ \ \ >x<rsup|p+1> <frac|dF|dx> =
    A<around*|(|x|)> F
  </equation*>

  <with|color|black|This pakcage deals with its local analysis>:

  <\equation*>
    <text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >A<around*|(|x|)> =
    <big|sum><rsub|k=0><rsup|\<infty\>> A<rsub|k> x<rsup|k>
    \<nocomma\>\<nocomma\>,<text| \ \ > A<rsub|k > \<in\>
    \<cal-M\><rsub|n><around*|(|\<bbb-C\>|)>
  </equation*>

  <with|color|black|A Fundamental Matrix of Formal Solutions (Hukuhara-
  Turritin- Levelt) is givne by:>

  <\equation*>
    \<Phi\><around*|(|x<rsup|1/s>|)> x<rsup|C> exp
    <around*|(|Q<around*|(|x<rsup|-1/s>|)>|)>
  </equation*>

  <\with|color|black>
    <\with|font-base-size|10>
      <\itemize-dot>
        <item><math|s\<in\> \<bbb-N\><rsup|\<ast\>><rsup|>>
        <with|font-base-size|10|<with|color|black|:
        \ \ \ \ \ \ \ <em|<with|font-shape|left-slanted|<with|font-shape|condensed|<em|ramification
        index>>>>>>
      </itemize-dot>

      <\itemize-dot>
        <item><with|color|black|<math|\<Phi\><around*|(|x<rsup|1/s>|)> : >
        \ \ \ \ \ root-meromorphic matrix in <math|x> over <math|\<bbb-C\>>>
      </itemize-dot>

      <\itemize-dot>
        <item><math|Q<around*|(|x<rsup|-1/s>|)> : > <dfn|
        \ exponen<em|<strong|>>tial part>,\ 

        \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ diagonal matrix of polynomials in
        <math|x<rsup|-1/s> >over <math|\<bbb-C\>> without constant terms
      </itemize-dot>

      <\itemize-dot>
        <item><math|C> : \ \ \ \ \ \ \ \ \ \ \ \ \ constant matrix which
        commutes with the exponential part

        <item><math|p> is called the Poincar rank\ 
      </itemize-dot>
    </with>

    <with|font-base-size|10|>
  </with>

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark blue| Construction
    of a fundamental matrix of formal solutions>
  </framed>

  \;

  <\itemize-dot>
    <item>Existence: Turrittin, Hukuhara, Levelt, Balser-Jurkat-Lutz,
    <math|\<ldots\>>
  </itemize-dot>

  <\itemize-dot>
    <item>Algorithms for related problems: Levelt, Hilali and Wazner
    (1980's), Sommeling (1993), Chen, Schaefke, Barkatou,(1990 - ...),
    Pfluegel (2000 - ...), <math|\<ldots\>>
  </itemize-dot>

  <\itemize-dot>
    <item>Books: Wasow (1965), Balser(2000), Hsieh and Sibuya (1999),
    <math|\<ldots\>>
  </itemize-dot>

  <\itemize-dot>
    <item>Package <name|Isolde> in <name|Maple> by M. A. Barkatou and E.
    Pfluegel (ISSAC'2012):

    http://sourceforge.net/projects/isolde
  </itemize-dot>

  \;

  The algorithms implemented herein decouple the input system to system(s) of
  <math|n=1> (scalar case) or <math|p=0> (regular system
  <math|\<rightarrow\>> zero exponential part) by a change of basis <math|F =
  T G> which yields an <em|equivalent> system

  <\equation*>
    <around*|[|<wide|A|~>|]> <text| \ \ \ \ \ \ \ \ \ >x<rsup|<wide|p|~>+1>
    <frac|dG|dx> = <wide|A|~><around*|(|x|)> G
  </equation*>

  such that

  <\equation*>
    <dfrac|<wide|A|~>|x<rsup|<wide|p|~>+1>> = T<rsup|-1>
    <dfrac|A|x<rsup|p+1>><text| > T <text| \ >- <text| \ > T<rsup|-1> <text|
    ><frac|dT|dx>
  </equation*>

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark
    blue|<name| Lindalg : >Main Functionalities>
  </framed>

  \;

  Formal Reduction:

  <\itemize-dot>
    <item>Splitting of system into systems of lower dimension

    <item>Rank Reduction (classification of singularity)

    <item><math|p=0> : Solutions of Regular System

    <item><math|p \<gtr\>0 > : Computing the exponential part (Irregular
    systems)

    <item>Solutions of n<math|<rsup|th>>-order linear singular differential
    equations (equivalence with first order systems)
  </itemize-dot>

  \;

  <\equation*>
    <around*|[|A|]> <text| \ \ \ \ \ \ \ \ \ >x<rsup|p+1> <frac|dF|dx> =
    A<around*|(|x|)> F = <around*|(| \ <big|sum><rsub|k=0><rsup|\<infty\>>
    A<rsub|k> x<rsup|k>|)><text| > F
  </equation*>

  \;

  \;

  The discussion depends on the eigenvalues of <math|A<rsub|0>>.

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark
    blue| Getting ready!>
  </framed>

  <name|Mathemagix> consists of a collection of packages which partially
  depend on each other. Currently, you may download the complete sources of
  Mathemagix from svn server and specify the individual packages that you
  want to use at the configuration stage. Details on installation are
  available on the <name|Mathemagix>'s webpage.\ 

  <\equation*>
    \;
  </equation*>

  We first start an interactive session and change to the correct directory:

  <\session|shell|default>
    <\output>
      Shell session inside TeXmacs pid = 4539
    </output>

    <\input|Shell] >
      cd /Users/maddah/Documents/mathemagix/mmx2
    </input>

    \;

    If you do not wish to install it, you can still use it via
    <em|development mode>. Hence, the following lines:

    \;

    <\input|Shell] >
      source set-devel-paths;./configure --enable-lindalg \<gtr\> /dev/null ;
      make \<gtr\> /dev/null
    </input>

    \;

    \;

    <verbatim|lindalg/mmx> contains the source code of the package and
    lindalg/test contains the test files. You can access the former if you
    wish to read and/or modify the code. If more help is needed on the syntax
    of <name|Mathemagix> then you can refer to mmx tutorial. However, if you
    only wish to use the package to compute with your own examples, then you
    can simply access the relevant test file and replace the input system by
    yours.\ 

    \;

    <\folded-io|Shell] >
      cd /Users/maddah/Documents/mathemagix/mmx2/lindalg/mmx;ls
    <|folded-io>
      algebraic_solve.mmx \ \ \ \ \ \ \ \ \ \ \ \ matrix_manip.mmx

      bad_spectrum.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ moser_barkatou.mmx

      block_diag.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ moser_barkatou_trans.mmx

      calgebraic \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ newton_polygon.mmx

      calgebraic.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ ralgebraic.mmx

      cball.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ ramification.mmx

      characteristic_polynomial.mmx \ \ rball.mmx

      column_operations.mmx \ \ \ \ \ \ \ \ \ \ reduced_poly.mmx

      exp_part.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ reg_singular.mmx

      exp_part_fns.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ rho_elim.mmx

      format_printing.mmx \ \ \ \ \ \ \ \ \ \ \ \ shearing.mmx

      gauss_elim.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ smart_ramification.mmx

      get_coeffs.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma

      int_bezout.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma.mmx

      katz_invariant.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma_trans.mmx

      lin_solve.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ sylvester_solve.mmx

      mat_pol_mult.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ tensor_product.mmx
    </folded-io>

    \;

    \;

    <\folded-io|Shell] >
      cd /Users/maddah/Documents/mathemagix/mmx2/lindalg/test;ls
    <|folded-io>
      block_diag_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ int_bezout_test.mmx

      calgebraic_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ inv_calgebraic_test.mmx

      calgebraic_test_print \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ katz_invariant_test.mmx

      cball_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ lin_solve_test

      characteristic_polynomial_test.mmx \ \ \ \ \ lin_solve_test.mmx

      column_operations_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ mat_pol_mult_test.mmx

      exp_part_fns_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ matrix_calgebraic_test.mmx

      exp_part_test \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ matrix_manip_test.mmx

      exp_part_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ moser_barkatou_test

      exp_part_test1a \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ moser_barkatou_test.mmx

      exp_part_test1a.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ moser_barkatou_trans_test.mmx

      exp_part_test1b \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ newton_polygon_test.mmx

      exp_part_test1b.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ poly_test.mmx

      exp_part_test2 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ presentation_greece_ACA2015

      exp_part_test2.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ quotient_test.mmx

      exp_part_test3 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ ralgebraic_test.mmx

      exp_part_test3.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ rball_test.mmx

      exp_part_test4 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ reduced_poly_test.mmx

      exp_part_test4.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ reg_singular_test.mmx

      exp_part_test5 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ rho_elim_test.mmx

      exp_part_test5.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ roots_test

      exp_part_test6 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ roots_test.mmx

      exp_part_test6.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ series_test.mmx

      exp_part_test7 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ shearing_test

      exp_part_test7.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ shearing_test.mmx

      exp_part_test8 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ smart_ramification_test.mmx

      exp_part_test8.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma_test.mmx

      exp_part_test9.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ sylvester_solve_test.mmx

      gauss_elim_test \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ tensor_product_test.mmx

      gauss_elim_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ test

      get_coeffs_test.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ test.mmx
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;

    \;
  </session>

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark
    blue| Test!>
  </framed>

  The example program can be run in two ways: by compiling it using the
  <name|Mathemagix> compiler mmc and then running the resulting executable,
  or by interpreting it using the <name|Mathemagix> interpreter (from mmx
  language tutorial, pp 9). In this manual, we use the compiler. All the
  following examples are grouped in a folder accompanying this manual. \ 

  <\session|shell|default>
    <\folded-io|Shell] >
      cd /Users/maddah/Documents/mathemagix/mmx2/lindalg/test/presentation_greece_ACA2015;ls
    <|folded-io>
      exp_part_test1a \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ pfaffA.mmx

      exp_part_test1a.mmx \ \ \ \ \ \ \ \ \ \ \ \ reg_singular_test

      exp_part_test3 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ reg_singular_test.mmx

      exp_part_test3.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma_trans_test

      exp_part_test4 \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma_trans_test.mmx

      exp_part_test4.mmx \ \ \ \ \ \ \ \ \ \ \ \ \ split_lemma_trans_test100

      moser_barkatou_test \ \ \ \ \ \ \ \ \ \ \ \ split_lemma_trans_test100.mmx

      moser_barkatou_test.mmx \ \ \ \ \ \ \ \ split_lemma_trans_test1000

      moser_barkatou_trans_test1 \ \ \ \ \ split_lemma_trans_test1000.mmx

      moser_barkatou_trans_test1.mmx \ split_lemma_trans_test2000

      moser_barkatou_trans_test2 \ \ \ \ \ split_lemma_trans_test2000.mmx

      moser_barkatou_trans_test2.mmx \ split_lemma_trans_test500

      moser_barkatou_trans_test3 \ \ \ \ \ split_lemma_trans_test500.mmx

      moser_barkatou_trans_test3.mmx \ split_sys_test

      moser_barkatou_trans_test4 \ \ \ \ \ split_sys_test.mmx

      moser_barkatou_trans_test4.mmx \ test

      pfaffA \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ test.mmx
    </folded-io>

    \;

    \;

    We start with the famous \ <verbatim|Hello World > example. One can
    optionally open and read the example file.\ 

    \;

    <\input|Shell] >
      open test.mmx<text|>
    </input>

    <\textput>
      To compile the program (In the examples which follow, we assume the
      programs are already compiled. We thus skip this step.):\ 
    </textput>

    <\input|Shell] >
      mmc test.mmx
    </input>

    <\textput>
      To run it:
    </textput>

    <\folded-io|Shell] >
      ./test\ 
    <|folded-io>
      Hello World!
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;

    \;
  </session>

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark blue| Splitting of system
    into subsystems of lower dimension> - Classical
  </framed>

  <\example>
    \ \ 

    <\eqnarray*>
      <tformat|<table|<row|<cell|x<rsup|3 > <frac|dF|dx> = A<around*|(|x|)>
      F<text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A<around*|(|x|)>
      = <matrix|<tformat|<table|<row|<cell|-2x+2>|<cell|6x<rsup|2>-x>|<cell|2x<rsup|2>-5x+5>|<cell|x<rsup|2>>>|<row|<cell|x<rsup|2>+x>|<cell|x>|<cell|x<rsup|2>-x>|<cell|3x+3>>|<row|<cell|3x<rsup|2>+3x+3>|<cell|<frac|4|5>
      x<rsup|2>+7x>|<cell|x<rsup|2>+x+8>|<cell|2x<rsup|2>+2x+2>>|<row|<cell|<frac|2|3>x<rsup|2>-<frac|1|5>x>|<cell|<frac|1|3>x<rsup|2>+<frac|2|3>x>|<cell|-2x<rsup|2>>|<cell|2x-1>>>>>>|<cell|>|<cell|>>>>
    </eqnarray*>
  </example>

  <math|><mmx|split_sys(A,p,m)> where <math|2> is the Poincar rank computes
  an equivalent block-diagonalized system (whenever possible) up to order
  <math|m> :

  <\eqnarray*>
    <tformat|<table|<row|<cell|x<rsup|3> <frac|dG|dx> =
    <wide|A|~><around*|(|x|)>G<text| \ \ \ \ \ where
    \ \ <math|<wide|A|~><around*|(|x|)>> is given by:>>|<cell|>|<cell|>>>>
  </eqnarray*>

  <math|>

  <\session|shell|default>
    <\output>
      Shell session inside TeXmacs pid = 9603
    </output>

    <\input|Shell] >
      open split_sys_test.mmx
    </input>

    <\folded-io|Shell] >
      ./split_sys_test
    <|folded-io>
      \;

      \ A block-diagonalized equivalent system is given (up to order 5) by:

      \ 

      [-15709552 / 46525 * x^4 - 15024 / 1861 * x^3 + 30509 / 9305 * x^2 -
      18422 / 1861 * x + 18422 / 1861, -87731389 / 51949815 * x^4 - 854468 /
      17316605 * x^3 - 37029 / 3463321 * x^2 + 22483 / 3463321 * x - 16900 /
      3463321, 125443 / 51949815 * x^4 + 162 / 3463321 * x^3 + 6 / 3463321 *
      x^2 - 5 / 3463321 * x + 5 / 3463321, 0; 35869394 / 75 * x^4 + 135823 /
      15 * x^3 - 23936 / 5 * x^2 - 1861 / 5 * x, 41437294 / 16749 * x^4 +
      1620016 / 27915 * x^3 + 3987 / 1861 * x^2 - 1, -287156 / 83745 * x^4 -
      376 / 5583 * x^3 - 14 / 5583 * x^2, 0; 955542377164 / 75 * x^4 +
      18962033242 / 75 * x^3 - 105740568 / 5 * x^2 + 68763947 * x + 3,
      27429116257853 / 418725 * x^4 + 44771091332 / 27915 * x^3 + 484224378 /
      9305 * x^2 - 138193299 / 1861 * x + 1022 / 1861, -7646109619 / 83745 *
      x^4 - 49933258 / 27915 * x^3 - 250981 / 5583 * x^2 + 16561 / 1861 * x +
      188 / 1861, 0; 0, 0, 0, 20233903 / 225 * x^4 + 8694 / 5 * x^3 + 608 /
      15 * x^2 + 3 * x]
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output here:

  <\eqnarray*>
    <tformat|<table|<row|<cell|x<rsup|3> <frac|dG|dx> =
    <wide|A|~><around*|(|x|)>G<text| \ \ \ \ \ where
    \ \ <math|<wide|A|~><around*|(|x|)>> is given by
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|
    >>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|
    <matrix|<tformat|<table|<row|<frac|18422|1861>-<frac|18422|1861>x+
    O<around*|(|x<rsup|2>|)>|<cell|-<frac|16900|3463321>+<frac|22483|3463321>x+O<around*|(|x<rsup|2>|)>>|<cell|<frac|5
    - 5x|3463321> +O<around*|(|x<rsup|2>|)>>|<cell|0>>|<row|-<frac|1861|5>x+O<around*|(|x<rsup|2>|)>|<cell|-1+O<around*|(|x<rsup|2>|)>>|<cell|O<around*|(|x<rsup|2>|)>>|<cell|0>>|<row|<cell|3+68763947x+O<around*|(|x<rsup|2>|)>>|<cell|<frac|1022-138193299
    x|1861>+O<around*|(|x<rsup|2>|)>>|<cell|<frac|188|1861>+O<around*|(|x<rsup|>|)>>|<cell|0>>|<row|<cell|0>|0|0|<cell|3x+O<around*|(|x<rsup|2><rsup|>|)>>>>>>>|<cell|>|<cell|>>>>
  </eqnarray*>

  \;

  \;

  <mmx|split_lemma_trans(A,2,m)> outputs the two uncoupled \ subsystems and
  the transformation <math|F = T G=T<matrix|<tformat|<table|<row|<cell|G<rsub|1>>>|<row|<cell|G<rsub|2>>>>>>
  > as well:

  \ 

  <\session|shell|default>
    <\input|Shell] >
      open split_lemma_trans_test.mmx
    </input>

    <\folded-io|Shell] >
      ./split_lemma_trans_test
    <|folded-io>
      \;

      \ The first subsystem, second subsystem, and the transition matrix are
      given (up to order 5) respectively by:\ 

      \ 

      [[-15709552 / 46525 * x^4 - 15024 / 1861 * x^3 + 30509 / 9305 * x^2 -
      18422 / 1861 * x + 18422 / 1861, -87731389 / 51949815 * x^4 - 854468 /
      17316605 * x^3 - 37029 / 3463321 * x^2 + 22483 / 3463321 * x - 16900 /
      3463321, 125443 / 51949815 * x^4 + 162 / 3463321 * x^3 + 6 / 3463321 *
      x^2 - 5 / 3463321 * x + 5 / 3463321; 35869394 / 75 * x^4 + 135823 / 15
      * x^3 - 23936 / 5 * x^2 - 1861 / 5 * x, 41437294 / 16749 * x^4 +
      1620016 / 27915 * x^3 + 3987 / 1861 * x^2 - 1, -287156 / 83745 * x^4 -
      376 / 5583 * x^3 - 14 / 5583 * x^2; 955542377164 / 75 * x^4 +
      18962033242 / 75 * x^3 - 105740568 / 5 * x^2 + 68763947 * x + 3,
      27429116257853 / 418725 * x^4 + 44771091332 / 27915 * x^3 + 484224378 /
      9305 * x^2 - 138193299 / 1861 * x + 1022 / 1861, -7646109619 / 83745 *
      x^4 - 49933258 / 27915 * x^3 - 250981 / 5583 * x^2 + 16561 / 1861 * x +
      188 / 1861], [20233903 / 225 * x^4 + 8694 / 5 * x^3 + 608 / 15 * x^2 +
      3 * x], [1861, 0, 0, 271013672 / 83745 * x^4 + 4619444 / 83745 * x^3 +
      5707 / 5583 * x^2 + 149 / 5583 * x; 0, -3, 0, -1316029 / 75 * x^4 -
      13571 / 45 * x^3 - 58 / 5 * x^2 + 2 / 3 * x + 1; 2940, -3380 / 1861, 1
      / 1861, -4965308090923 / 225 * x^4 - 16931802862 / 45 * x^3 - 104929688
      / 15 * x^2 - 541099 / 3 * x; 908098008 / 25 * x^4 + 17763532 / 25 * x^3
      + 68466 / 5 * x^2 - 1109 / 5 * x, 25943364844 / 139575 * x^4 +
      102373093 / 27915 * x^3 + 813428 / 9305 * x^2 - 1368 / 1861 * x + 1,
      -8138026 / 27915 * x^4 - 142183 / 27915 * x^3 - 186 / 1861 * x^2 - 4 /
      1861 * x, 0]]
    </folded-io>

    \;

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output here:

  <\eqnarray*>
    <tformat|<table|<row|<cell|T<around*|(|x|)> =
    <matrix|<tformat|<table|<row|<cell|1861>|<cell|0>|<cell|0>|<cell|<frac|149|5583>
    x \<noplus\>>>|<row|<cell|0>|<cell|-3>|<cell|0>|<cell|1
    \<noplus\>+<frac|2|3>x>>|<row|<cell|2940>|<cell|-<frac|3380|1861>>|<cell|<frac|1|1861>>|<cell|-
    <frac|541099|3>x>>|<row|<cell|- <frac|1109|5>x>|<cell|- <frac|1368|1861>x
    +1>|<cell|-<frac|4|1861>x>|<cell|0>>>>> \<noplus\> \<noplus\>+
    O<around*|(|x<rsup|2>|)> <text| \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|x<rsup|3
    > <frac|dG<rsub|1>|dx> = <wide|A<rsub|1>|~><around*|(|x|)>
    G<rsub|1><text| \ and \ \ \ <math|x<rsup|3 > <frac|dG<rsub|2>|dx> =
    <wide|A<rsub|2>|~><around*|(|x|)> G<rsub|2><text|
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>>>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<text|where
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<wide|A<rsub|1>|~><around*|(|x|)>
    = <matrix|<tformat|<table|<row|<cell|<frac|18422|1861>-<frac|18422|1861>x+
    O<around*|(|x<rsup|2>|)>>|<cell|-<frac|16900|3463321>+<frac|22483|3463321>x+O<around*|(|x<rsup|2>|)>>|<cell|<frac|5
    - 5x|3463321> +O<around*|(|x<rsup|2>|)>>>|<row|<cell|-<frac|1861|5>x+O<around*|(|x<rsup|2>|)>>|<cell|-1+O<around*|(|x<rsup|2>|)>>|O<around*|(|x<rsup|2>|)>>|<row|<cell|3+68763947x+O<around*|(|x<rsup|2>|)>>|<cell|<frac|1022-138193299
    x|1861>+O<around*|(|x<rsup|2>|)>>|<cell|<frac|188|1861>+O<around*|(|x<rsup|>|)>>>>>><text|
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<wide|A<rsub|2>|~><around*|(|x|)>=<matrix|<tformat|<table|<row|<cell|3x+O<around*|(|x<rsup|2><rsup|>|)>>>>>>
    <text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>>>
  </eqnarray*>

  \;

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ <with|color|dark blue| Rank Reduction
    (classification of singularity)> - Moser'59 and Barkatou'95 \ \ \ 
  </framed>

  <\example>
    \ Irregular system (Poincar rank drops) \ 

    <\eqnarray*>
      <tformat|<table|<row|<cell|x<rsup|8 > <frac|dF|dx> = A<around*|(|x|)>
      F<text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A<around*|(|x|)>
      = <matrix|<tformat|<table|<row|<cell|4x<rsup|7>>|<cell|x<rsup|10>>|<cell|-2x<rsup|13>>|<cell|-x<rsup|13>>>|<row|<cell|0>|<cell|-x<rsup|7>-x<rsup|6>>|<cell|x<rsup|6>>|<cell|0>>|<row|<cell|1>|<cell|0>|<cell|x<rsup|6>-2x<rsup|7>>|<cell|x<rsup|6>>>|<row|<cell|x<rsup|2>+x>|<cell|-x<rsup|5>>|<cell|x<rsup|9>+x<rsup|8>+x<rsup|5>>|<cell|-3x<rsup|7>>>>>>>|<cell|>|<cell|>>>>
    </eqnarray*>
  </example>

  <math|><mmx|moser_barkatou(A,p)> where <math|7> is the Poincar rank
  computes an equivalent rank_reduced system. This command is to be used in
  case the true Poincar rank is already known (which is 2 here):

  <math|>

  <\equation*>
    x<rsup|3> <frac|dG|dx> = <wide|A|~><around*|(|x|)>G\ 
  </equation*>

  \;

  <\session|shell|default>
    <\input|Shell] >
      open moser_barkatou_test.mmx
    </input>

    <\folded-io|Shell] >
      ./moser_barkatou_test
    <|folded-io>
      \;

      \ Moser-barkatou reduction computes an equivalent system:\ 

      \ 

      [-2 * x^2 - x, 0, x, 0; 1, -2 * x^2, -2 * x^3, -x^2; 0, 1, -3 * x^2 +
      x, 1; -x, x^3 + x^2, x^5 + x^4 + x, -3 * x^2]
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the output here:

  <\equation*>
    <wide|A|~><around*|(|x|)> = \ <matrix|<tformat|<table|<row|<cell|-2x<rsup|2>-x>|<cell|0>|<cell|x>|<cell|0>>|<row|<cell|1>|<cell|-2x<rsup|2>>|<cell|-2x<rsup|3>>|<cell|-x<rsup|2>>>|<row|<cell|0>|<cell|1>|<cell|-3x<rsup|2>+x>|<cell|1>>|<row|<cell|-x>|<cell|x<rsup|3>+x<rsup|2>>|<cell|x<rsup|5>+x<rsup|4>+x>|<cell|-3x<rsup|2>>>>>>
  </equation*>

  <mmx|moser_barkatou_trans(A,p)> outputs an equivalent rank-reduced system,
  the transformation <math|F = T G \<nocomma\> and the >true Poincar rank as
  well:

  <\session|shell|default>
    <\input|Shell] >
      open moser_barkatou_trans_test1.mmx
    </input>

    <\input|Shell] >
      \;
    </input>
  </session>

  <\session|shell|default>
    <\folded-io|Shell] >
      ./moser_barkatou_trans_test1
    <|folded-io>
      \;

      \ Moser-barkatou reduction computes an equivalent system, a
      transformation, and the true Poincare rank to be: \ 

      \ 

      [[-2 * x^2 - x, 0, x, 0; 1, -2 * x^2, -2 * x^3, -x^2; 0, 1, -3 * x^2 +
      x, 1; -x, x^3 + x^2, x^5 + x^4 + x, -3 * x^2], [0, x^6, 0, 0; x, 0, 0,
      0; 0, 0, x, 0; 0, 0, 0, 1], 2]
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output here:

  \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <math|<wide|A|~><around*|(|x|)>
  = \ <matrix|<tformat|<table|<row|<cell|-2x<rsup|2>-x>|<cell|0>|<cell|x>|<cell|0>>|<row|<cell|1>|<cell|-2x<rsup|2>>|<cell|-2x<rsup|3>>|<cell|-x<rsup|2>>>|<row|<cell|0>|<cell|1>|<cell|-3x<rsup|2>+x>|<cell|1>>|<row|<cell|-x>|<cell|x<rsup|3>+x<rsup|2>>|<cell|x<rsup|5>+x<rsup|4>+x>|<cell|-3x<rsup|2>>>>>>
  >

  <\equation*>
    T<around*|(|x|)> = <matrix|<tformat|<table|<row|<cell|0>|<cell|x<rsup|6>>|<cell|0>|<cell|0>>|<row|<cell|x>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|x>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|1>>>>>
  </equation*>

  \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ True
  Poincar rank = 2

  <\example>
    \ Irregular system ( rank of leading coefficient matrix drops)\ 

    <\eqnarray*>
      <tformat|<table|<row|<cell| x<rsup|2 > <frac|dF|dx> = A<around*|(|x|)>
      F<text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A<around*|(|x|)>
      = <text|><matrix|<tformat|<table|<row|<cell|4>|<cell|2x>|<cell|0>|<cell|0>|<cell|0>|<cell|2x>>|<row|<cell|0>|<cell|2>|<cell|2x-1>|<cell|0>|<cell|x>|<cell|0>>|<row|<cell|4x>|<cell|-2>|<cell|1>|<cell|0>|<cell|-x>|<cell|8x>>|<row|<cell|x>|<cell|2>|<cell|0>|<cell|2x>|<cell|0>|<cell|0>>|<row|<cell|8>|<cell|x+4>|<cell|-1>|<cell|2x>|<cell|x>|<cell|-4x>>|<row|<cell|0>|<cell|2x>|<cell|0>|<cell|0>|<cell|0>|<cell|x>>>>>>|<cell|>|<cell|>>>>
    </eqnarray*>
  </example>

  <mmx|moser_barkatou_trans(A,1)> outputs an equivalent rank-reduced system,
  the transformation <math|F = T G \<nocomma\> and the >true Poincar rank as
  well:

  \ \ \ 

  <\session|shell|default>
    <\input|Shell] >
      open moser_barkatou_trans_test4.mmx
    </input>

    <\folded-io|Shell] >
      ./moser_barkatou_trans_test4
    <|folded-io>
      \;

      \ Moser-barkatou reduction computes an equivalent system, a
      transformation, and the true Poincare rank to be: \ 

      \ 

      [[-x + 4, 2 * x, x, 0, 0, 2 * x; -2 * x, -x + 3, 2 * x, 3 / 2, 3 / 2 *
      x, -4 * x; 4 * x, -2, -x, -1, -x, 8 * x; x^2, 2 * x, x, 2 * x, 0, 0; -x
      + 8, x + 2, 1 / 2 * x, 1, 0, -4 * x; 0, 2 * x, x, 0, 0, 0], [x, 0, 0,
      0, 0, 0; 0, x, 1 / 2 * x, 0, 0, 0; 0, 0, x, 0, 0, 0; 0, 0, 0, 1, 0, 0;
      0, 0, 0, 1, x, 0; 0, 0, 0, 0, 0, x], 1]

      \ 

      \ 
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  <\equation*>
    x<rsup|2><frac|dG|dx> = <wide|A|~><around*|(|x|)>G =
    <matrix|<tformat|<table|<row|<cell|-x+4>|<cell|2x>|<cell|x>|<cell|0>|<cell|0>|<cell|2x>>|<row|<cell|-2x>|<cell|-x+3>|<cell|2x>|<cell|<frac|3|2>>|<cell|<frac|3|2>x>|<cell|-4x>>|<row|<cell|4x>|<cell|-2>|<cell|-x>|<cell|-1>|<cell|-x>|<cell|8x>>|<row|<cell|x<rsup|2>>|<cell|2x>|<cell|x>|<cell|2x>|<cell|0>|<cell|0>>|<row|<cell|-x+8>|<cell|x+2>|<cell|<frac|1|2>x>|<cell|1>|<cell|0>|<cell|-4x>>|<row|<cell|0>|<cell|2x>|<cell|x>|<cell|0>|<cell|0>|<cell|0>>>>>G
  </equation*>

  \;

  <\equation*>
    T<around*|(|x|)> = <matrix|<tformat|<table|<row|<cell|x>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|x>|<cell|<frac|1|2>x>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|x>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|1>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|1>|<cell|x>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|x>>>>>
  </equation*>

  \;

  \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ True
  Poincar rank = 1

  \;

  \;

  <\example>
    \ Regular system (Poincar rank drops to zero) \ 

    <\eqnarray*>
      <tformat|<table|<row|<cell|x<rsup|3 > <frac|dF|dx> = A<around*|(|x|)>
      F<text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A<around*|(|x|)>
      = <matrix|<tformat|<table|<row|<cell|6x<rsup|3>>|<cell|27x<rsup|4>>|<cell|6x<rsup|2>>|<cell|7x<rsup|5>>>|<row|<cell|0>|<cell|x<rsup|4>>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|x<rsup|><rsup|2>>|<cell|0>>|<row|<cell|-6>|<cell|0>|<cell|0>|<cell|0>>>>>>|<cell|>|<cell|>>>>
    </eqnarray*>
  </example>

  <math|><mmx|moser_barkatou_trans(A,2)> outputs an equivalent rank-reduced
  system, the transformation <math|F = T G \<nocomma\>and the >true Poincar
  rank as well:

  <\session|shell|default>
    \;

    <\folded-io|Shell] >
      ./moser_barkatou_trans_test3
    <|folded-io>
      \;

      \ Moser-barkatou reduction computes an equivalent system, a
      transformation, and the true Poincare rank to be:\ 

      \ 

      [[-1, 0, 0, 0; 6, 6 * x - 2, 27, 7 * x; 0, 0, x^2, 0; 0, -6, 0, 0], [0,
      x^2, 0, 0; 0, 0, 1, 0; x^2, 0, 0, 0; 0, 0, 0, 1], 0]
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  <\equation*>
    x <frac|dG|dx> = <wide|A|~><around*|(|x|)>G =
    \ <matrix|<tformat|<table|<row|<cell|-1>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|6>|<cell|6x-2>|<cell|27>|<cell|7x>>|<row|<cell|0>|<cell|0>|<cell|x<rsup|2>>|<cell|0>>|<row|<cell|0>|<cell|-6>|<cell|0>|<cell|0>>>>>
    G
  </equation*>

  \;

  <\equation*>
    T<around*|(|x|)> = <matrix|<tformat|<table|<row|<cell|0>|<cell|x<rsup|2>>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|1>|<cell|0>>|<row|<cell|x<rsup|2>>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|1>>>>>
  </equation*>

  \;

  \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ True
  Poincar rank = 0

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark
    blue|<math|p=0 : > Solutions of a regular system> - Classical
  </framed>

  <\example>
    \ 

    <\eqnarray*>
      <tformat|<table|<row|<cell|x<rsup| > <frac|dF|dx> = A<around*|(|x|)>
      F<text| \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A<around*|(|x|)>
      = <matrix|<tformat|<table|<row|<cell|a<around*|(|x|)>>|<cell|0>|0|<cell|0>>|<row|<cell|0>|2
      a<around*|(|x|)>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|<rsup|>2a<around*|(|x|)>>|<cell|-2a<around*|(|x|)>>>|<row|<cell|<frac|-1
      +a<around*|(|x|)>+x<rsup|6>|2>>|<cell|<frac|1
      -a<around*|(|x|)>-x<rsup|6>|2>>|<cell|<frac|-1
      +a<around*|(|x|)>+x<rsup|6>|2>>|<cell|1 -<frac|
      a<around*|(|x|)>+x<rsup|6>|2>>>>>>>|<cell|>|<cell|>>>>
    </eqnarray*>
  </example>

  where <math|a<around*|(|x|)> = <tabular|<tformat|<table|<row|<cell|x
  -x<rsup|2>+x<rsup|3>-x<rsup|4>+x<rsup|5>-x<rsup|6>>>>>>>.

  <math|><mmx|reg_singular(A,m)> computes a fundamental matrix of formal
  solutions up to order <math|m> (whether the leading matrix coefficient has
  good or bad spectrum). For m=4 we have:

  \;

  <\session|shell|default>
    <\folded-io|Shell] >
      ./reg_singular_test
    <|folded-io>
      This system is regular singular and a FMFS up to order 4 is given by:
      \ \ [[algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)),
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)), algebraic
      (0, Field (x, 0e-323228496 + 0e-323228496 * i)), algebraic (0, Field
      (x, 0e-323228496 + 0e-323228496 * i)); algebraic (0, Field (x,
      0e-323228496 + 0e-323228496 * i)), algebraic (0, Field (x, 0e-323228496
      + 0e-323228496 * i)), algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)), algebraic (0, Field (x, 0e-323228496 + 0e-323228496
      * i)); algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)),
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)), algebraic
      (0, Field (x, 0e-323228496 + 0e-323228496 * i)), algebraic (0, Field
      (x, 0e-323228496 + 0e-323228496 * i)); algebraic (1 / 2, Field (x,
      0e-323228496 + 0e-323228496 * i)), algebraic (-1 / 2, Field (x,
      0e-323228496 + 0e-323228496 * i)), algebraic (1 / 2, Field (x,
      0e-323228496 + 0e-323228496 * i)), algebraic (0, Field (x, 0e-323228496
      + 0e-323228496 * i))], [algebraic (1, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (1, Field (x, 0e-323228496 +
      0e-323228496 * i)), 0, 0, 0; 0, algebraic (1, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^2 + algebraic (2, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (1, Field (x, 0e-323228496 +
      0e-323228496 * i)), 0, 0; algebraic (-1 / 18, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^3 + algebraic (1 / 4, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^2 + algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)), algebraic (7 / 18, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^3 + algebraic (-1 / 4, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^2 + algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)), algebraic (-7 / 18, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^3 + algebraic (5 / 4, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^2 + algebraic (2, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (1, Field (x, 0e-323228496 +
      0e-323228496 * i)), algebraic (1 / 3, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^3 + algebraic (-1, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^2 + algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (0, Field (x, 0e-323228496 +
      0e-323228496 * i)); algebraic (7 / 1728, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^4 + algebraic (-17 / 288, Field (x, 0e-323228496
      + 0e-323228496 * i)) * x^3 + algebraic (3 / 8, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^2 + algebraic (1 / 2, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (1 / 2, Field (x, 0e-323228496 +
      0e-323228496 * i)), algebraic (-91 / 1728, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^4 + algebraic (101 / 288, Field (x, 0e-323228496
      + 0e-323228496 * i)) * x^3 + algebraic (-11 / 8, Field (x, 0e-323228496
      + 0e-323228496 * i)) * x^2 + algebraic (-1, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x + algebraic (-1 / 2, Field (x, 0e-323228496 +
      0e-323228496 * i)), algebraic (91 / 1728, Field (x, 0e-323228496 +
      0e-323228496 * i)) * x^4 + algebraic (-101 / 288, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x^3 + algebraic (11 / 8, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x^2 + algebraic (1, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x + algebraic (1 / 2, Field (x,
      0e-323228496 + 0e-323228496 * i)), algebraic (-7 / 144, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x^4 + algebraic (7 / 24, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x^3 + algebraic (-1, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x^2 + algebraic (1, Field (x,
      0e-323228496 + 0e-323228496 * i)) * x + algebraic (0, Field (x,
      0e-323228496 + 0e-323228496 * i))]]
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rerwrite the above output:

  <\equation*>
    F = \<Phi\><around*|(|x|)><text| \ > x<rsup|C>
  </equation*>

  where

  <\equation*>
    <text|C = \ \ <math| <matrix|<tformat|<table|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|<frac|1|2>>|<cell|<frac|-1|2>>|<cell|<frac|1|2>>|<cell|0>>>>>>
    \ \ \ \ and \ \ \ \ > \<Phi\><around*|(|x|)> =
    <matrix|<tformat|<table|<row|<cell|1+x>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|x<rsup|2>+2x+1>|<cell|0>|<cell|0>>|<row|<cell|<frac|1|4>x<rsup|2>>|<cell|-
    <frac|1|4>x<rsup|2>>|<cell|<frac|5|4>x<rsup|2>+2x+1>|<cell|-x<rsup|2>>>|<row|<cell|<frac|3|8>x<rsup|2>+<frac|1|2>x+<frac|1|2>>|<cell|-
    <frac|11|8>x<rsup|2>-x-<frac|1|2>>|<cell|
    <frac|11|8>x<rsup|2>+x+<frac|1|2>>|<cell|-x<rsup|2>+x>>>>><text|
    \ <math|\<noplus\> >>\<noplus\>\<noplus\>+O<around*|(|x<rsup|3>|)>
  </equation*>

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ <with|color|dark blue|<math|p\<gtr\>0 : > Computing the
    exponential part \ of an irregular system> - Barkatou'97 \ 
  </framed>

  <\example>
    \ Irregular system\ 

    \;
  </example>

  <\equation*>
    x<rsup|3> <frac|dF|dx> = A<around*|(|x|)>F =
    \ <matrix|<tformat|<table|<row|<cell|-2x<rsup|2>-x>|<cell|0>|<cell|x>|<cell|0>>|<row|<cell|1-x>|<cell|-x+x<rsup|3>>|<cell|x-2x<rsup|3>+x<rsup|4>+x<rsup|5>>|<cell|-3x<rsup|23>-x<rsup|4>>>|<row|<cell|0>|<cell|1>|<cell|-3x<rsup|2>+x>|<cell|1>>|<row|<cell|-x>|<cell|x<rsup|3>+x<rsup|2>>|<cell|x<rsup|4>+x<rsup|3>+x>|<cell|-4x<rsup|2>-x<rsup|3>>>>>>
    F
  </equation*>

  \;

  <mmx|exp_part_clag(A,2)> where <math|2> is the Poincar rank computes the
  exponential part

  <\session|shell|default>
    <\folded-io|Shell] >
      ./exp_part_test1a
    <|folded-io>
      \ 

      \ The exponential part in a Fundamental Matrix of Formal Solutions of A
      with p=2 is:

      \ 

      \ 

      [[algebraic (-1, Field (x, 0e-323228496 + 0e-323228496 * i)) /
      (algebraic (2, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^2 +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)) * x +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i))), (algebraic
      (-590 / 81, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^4 +
      algebraic (25 / 27, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^3 +
      algebraic (5 / 3, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^2 +
      algebraic (-5 / 4, Field (x, 0e-323228496 + 0e-323228496 * i)) * x +
      algebraic (-3, Field (x, 0e-323228496 + 0e-323228496 * i))) /
      (algebraic (5, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^5 +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^4 +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^3 +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^2 +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)) * x +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)))], [algebraic
      (1, Field (x, 0e-323228496 + 0e-323228496 * i)) * x + algebraic (0,
      Field (x, 0e-323228496 + 0e-323228496 * i)), algebraic (1, Field (x -
      1, 1.000000000000000000)) * x^3 + algebraic (0, Field (x - 1,
      1.000000000000000000)) * x^2 + algebraic (0, Field (x - 1,
      1.000000000000000000)) * x + algebraic (0, Field (x - 1,
      1.000000000000000000))], [1, 1]]

      \ 

      \;
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output:

  <\equation*>
    Q<around*|(|t|)>: <around*|[| <frac|-1|2t<rsup|2>> \<nocomma\>
    \<nocomma\>, <frac|-118|81 t> +<frac|5|27 t<rsup|2>>+\<nocomma\>
    <frac|1|3 t<rsup|3>><rsup|>-<frac|1|2 t<rsup|2>>-<frac|3|5 t<rsup|5>> |]>
  </equation*>

  <\equation*>
    x=<around*|[| t,t<rsup|3>|]>\ 
  </equation*>

  <\equation*>
    multiplicity = <around*|[|1,1|]>
  </equation*>

  As you can notice, the computations are always up to conjugates!

  \;

  \;

  <\example>
    \ Irregular system\ 

    \;
  </example>

  <\equation*>
    x<rsup|2> <frac|dF|dx> = A<around*|(|x|)>F=
    \ <matrix|<tformat|<table|<row|<cell|-x>|<cell|<frac|2|3><around*|(|x-1|)>>|<cell|<frac|16|9>x>>|<row|<cell|0>|<cell|-x>|<cell|<frac|4|3>x>>|<row|<cell|<frac|9|4>>|<cell|<frac|3|4><around*|(|x+1|)>>|<cell|-x>>>>>
    F
  </equation*>

  \;

  <mmx|exp_part_clag(A,2)> where <math|2> is the Poincar rank computes the
  exponential part

  \;

  <\session|shell|default>
    <\folded-io|Shell] >
      ./exp_part_test4
    <|folded-io>
      \;

      \ 

      \ The exponential part in a FMFS of A with p=1 is:\ 

      \;

      [[(algebraic (-10, Field (x, 0e-323228496 + 0e-323228496 * i)) * x +
      algebraic (6, Field (x, 0e-323228496 + 0e-323228496 * i))) / (algebraic
      (2, Field (x, 0e-323228496 + 0e-323228496 * i)) * x^2 + algebraic (0,
      Field (x, 0e-323228496 + 0e-323228496 * i)) * x + algebraic (0, Field
      (x, 0e-323228496 + 0e-323228496 * i)))], [algebraic (-1 / 2, Field (x +
      2, -2.000000000000000000)) * x^3 + algebraic (0, Field (x + 2,
      -2.000000000000000000)) * x^2 + algebraic (0, Field (x + 2,
      -2.000000000000000000)) * x + algebraic (0, Field (x + 2,
      -2.000000000000000000))], [1]]

      \;
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output:

  <\equation*>
    Q<around*|(|t|)>: <around*|[| <frac|-10t \<noplus\>+6|2t<rsup|2>> |]>
  </equation*>

  <\equation*>
    x=<around*|[| -<frac|1|2>t<rsup|3>|]>\ 
  </equation*>

  <\equation*>
    multiplicity = <around*|[|1|]>
  </equation*>

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark blue|
    \ Solutions of an n<math|<rsup|th>>-order linear singular differential
    equation> - Trivial \ \ \ \ \ \ \ 
  </framed>

  <\example>
    \ Irregular system associated to the equation:

    <\equation*>
      f<rsup|<around*|(|6|)>> -x<rsup|6> f<rsup|<around*|(|5|)>>-x<rsup|3>f<rprime|''>
      +f=0
    </equation*>

    \;
  </example>

  <\equation*>
    x<rsup|9> <frac|dF|dx> = A<around*|(|x|)>F =
    <text|><matrix|<tformat|<table|<row|<cell|0>|<cell|x<rsup|9>>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|0|<cell|x<rsup|9>>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|x<rsup|9>>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|x<rsup|9>>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|x<rsup|9>>>|<row|<cell|-1>|<cell|0>|<cell|x<rsup|3>>|<cell|0>|<cell|x<rsup|6>>|<cell|0>>>>>
    F
  </equation*>

  \;

  <mmx|exp_part_clag(A,2)> where <math|2> is the Poincar rank computes the
  exponential part

  <\session|shell|default>
    <\folded-io|Shell] >
      ./exp_part_test3
    <|folded-io>
      The exponential part in a FMFS of A with p=8 is:

      \ 

      [[algebraic (-2, Field (x, 0e-323228496 + 0e-323228496 * i)) /
      (algebraic (1, Field (x, 0e-323228496 + 0e-323228496 * i)) * x +
      algebraic (0, Field (x, 0e-323228496 + 0e-323228496 * i)))], [algebraic
      (1, Field (x - 1, 1.000000000000000000)) * x^2 + algebraic (0, Field (x
      - 1, 1.000000000000000000)) * x + algebraic (0, Field (x - 1,
      1.000000000000000000))], [1]]

      \ 

      \;
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output:

  <\equation*>
    Q<around*|(|t|)>: <around*|[| <frac|-2|t<rsup|>> \<nocomma\> \<nocomma\>
    |]>
  </equation*>

  <\equation*>
    x=<around*|[|t<rsup|2>|]>\ 
  </equation*>

  <\equation*>
    multiplicity = <around*|[|1|]>
  </equation*>

  \;

  <\example>
    \ \ 

    <\equation*>
      x<rsup|9> f<rprime|'''> -<rsub|><around*|(|-6x<rsup|8>+\<noplus\>x<rsup|7>*+4x<rsup|6>|)>
      f<rprime|''>- <around*|(|-6x<rsup|7>+2x<rsup|6>+3x<rsup|5>
      -3x<rsup|4>-5x<rsup|3>|)>f<rprime|'> - <around*|(|2x<rsup|3>\<noplus\>+
      \<noplus\>6x<rsup|2>+2x+2|)>f =0
    </equation*>

    <\eqnarray*>
      <tformat|<table|<row|<cell|<text|Let
      >F=<around*|[|f,f<rprime|'>,f<rprime|''>|]><rsup|T><text| \ then
      \ \ \ >x<rsup|9 > <frac|dF|dx> = A<around*|(|x|)> F<text|
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ >>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|A<around*|(|x|)>
      = <matrix|<tformat|<table|<row|<cell|0>|<cell|x<rsup|9>>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|x<rsup|9>>>|<row|<cell|2x<rsup|3>\<noplus\>+
      \<noplus\>6x<rsup|2>+2x+2>|<cell|-6x<rsup|7>+2x<rsup|6>+3x<rsup|5>
      -3x<rsup|4>-5x<rsup|3>>|<cell|-6x<rsup|8>+x<rsup|7>+4x<rsup|6>>>>>>>|<cell|>|<cell|>>>>
    </eqnarray*>
  </example>

  <mmx|moser_barkatou_trans(A,p)> outputs an equivalent rank-reduced system,
  the transformation <math|F = T G \<nocomma\>and the >true Poincar rank:

  \;

  <\session|shell|default>
    <\folded-io|Shell] >
      ./moser_barkatou_trans_test2
    <|folded-io>
      \;

      \ Moser-barkatou reduction computes an equivalent system, a
      transformation, and the true Poincare rank to be: \ 

      \ 

      [[-3 * x^2, 0, 1; 4 * x^3 - 15 / 2 * x^2 + 1, -6 * x^2, x - 5 / 2; -8 *
      x^4 + x^3 + 16 * x^2, 2 * x^3 + 6 * x^2 + 2 * x + 2, -6 * x^2 + x + 4],
      [-x^7 + 5 / 2 * x^6, x^6, 0; x^3, 0, 0; 0, 0, 1], 2]

      \ 

      \ 
    </folded-io>

    <\input|Shell] >
      \;
    </input>

    \;
  </session>

  We rewrite the above output:

  <\equation*>
    x<rsup|3><frac|dG|dx> = <wide|A|~><around*|(|x|)>G
    =<matrix|<tformat|<table|<row|<cell|-3x<rsup|2>>|<cell|0>|<cell|1>>|<row|<cell|4x<rsup|3>-<frac|15|2>x<rsup|2>+1>|<cell|-6x<rsup|2>>|<cell|x<rsup|>-<frac|5|2>>>|<row|-8x<rsup|4>
    +x<rsup|3>+16x<rsup|2><rsup|>|<cell|2x<rsup|3>+6x<rsup|2>+2x+2>|<cell|-6x<rsup|2>+x+4>>>>>
    G
  </equation*>

  \;

  <\equation*>
    T<around*|(|x|)> = <matrix|<tformat|<table|<row|<cell|-x<rsup|7>+<frac|5|2>x<rsup|6>>|<cell|x<rsup|6>>|<cell|0>>|<row|<cell|x<rsup|3>>|<cell|0>|<cell|0>>|<row|<cell|0>|<cell|0>|<cell|1>>>>>
  </equation*>

  \;

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark
    blue| What else to experiment with <name|Lindalg ?>>
  </framed>

  <\itemize-dot>
    <item>Each function is implemented for the most general algebraic
    structure (e.g. shearing trasformations are over rings,
    Block-diagonalization over fields,...)

    <item>Distinct fundamental transformations are implemented in separate
    files.

    <item>The functionalities of <name|Lindalg> can be used to compute some
    formal invariants of completely integrable Pfaffian systems and
    singularly-perturbed linear differential systems (see PhD thesis'2015,
    maddah)\ 

    <item>Code can be re-used for other problems specific to linear algebra
    by restricting the transformation to the similarity term.

    <\example>
      Writing an algebraic version of Moser-Barkatou algorithm for the
      algebraic eigenvalue problem.
    </example>

    <item>Compute 500, 800, 1000, ... terms in the series expansion of the
    equivalent system and for reduction of matrices of higher dimensions

    <\example>
      <\session|shell|default>
        <\output>
          Shell session inside TeXmacs pid = 4452
        </output>

        <\input>
          Shell]\ 
        <|input>
          ./split_lemma_trans_test500
        </input>
      </session>
    </example>
  </itemize-dot>

  \;

  \;

  <\framed>
    \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ <with|color|dark
    blue| \ To do...>
  </framed>

  \;

  So far...

  <\itemize-dot>
    <item><name|Lindalg > comes with the current release of <name|Mathemagix>

    <item>Accompanied with examples and can serve for research and
    pedagogical goals.
  </itemize-dot>

  <\itemize-dot>
    <item>This manual and a tutorial of formal reduction are available at:

    <hlink|<verbatim|www.unilim.fr/pages_perso/suzy.maddah/Research_.html>|www.unilim.fr/pages_perso/suzy.maddah/Research_.html>
  </itemize-dot>

  \;

  To do ...

  <\itemize-dot>
    <item>Expand to include all functionalities of <name|Isolde ( >e.g.
    rational solutions, ...)

    <item>Build up on it to rewrite other packages \ which we are being
    written in <em|<name|Maple>>: apparent singularities, perturbed systems,
    pfaffian systems.
  </itemize-dot>

  \;
</body>

<\initial>
  <\collection>
    <associate|bg-color|<pattern|/Applications/TeXmacs-1.99.1.app/Contents/Resources/share/TeXmacs/misc/patterns/ice-light.png||>>
    <associate|info-flag|none>
  </collection>
</initial>